<?php
class smilepayatm{
    var $code, $title, $titlep, $description, $enabled;

	function smilepayatm() {
      global $order,$db;

      $this->code = 'smilepayatm';
      $this->title = MODULE_PAYMENT_SMILEPAYATM_TEXT_TITLE; 
      $this->titlep = MODULE_PAYMENT_SMILEPAYATM_TEXT_TITLEP;
      $this->description = MODULE_PAYMENT_SMILEPAYATM_TEXT_DESCRIPTION;
      $this->sort_order = MODULE_PAYMENT_SMILEPAYATM_SORT_ORDER;
      $this->enabled = ((MODULE_PAYMENT_SMILEPAYATM_STATUS == 'True') ? true : false);
      //$this->form_action_url = MODULE_PAYMENT_SMILEPAYATM_KEY_URL;
      
      
      if ((int)MODULE_PAYMENT_SMILEPAYATM_ORDER_STATUS_ID > 0) {
        $this->order_status = MODULE_PAYMENT_SMILEPAYATM_ORDER_STATUS_ID;
      }

  }

	function update_status() {
      global $order,$db;

      if ( ($this->enabled == true) && ((int)MODULE_PAYMENT_SMILEPAYATM_ZONE > 0) ) {
        $check_flag = false;
        $check_query = xtc_db_query("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_SMILEPAYATM_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");  
        //$check_zone_id = xtc_db_fetch_array($check_query);     
        while ($check = xtc_db_fetch_array($check_query)) {
          if ($check['zone_id'] < 1) {
            $check_flag = true;
            break;
          } elseif ($check['zone_id'] == $order->billing['zone_id']) {
            $check_flag = true;
            break;
          }       
          if ($check_flag == false) {
          $this->enabled = false;
          }
       }
      }
    }

    function javascript_validation() {     
      return false;
    }

   function selection() {	         
      $selection = array('id' => $this->code,
                       'module' => $this->titlep,                       
                       'fields' => array(array('title' => MODULE_PAYMENT_SMILEPAYATM_PAYER_NAME,),));
        return $selection;               
	 } 

    function pre_confirmation_check() {
      global $order,$HTTP_POST_VARS;
      $DealerCode=MODULE_PAYMENT_SMILEPAYATM_DEALERCODE;
       if ( $order->info[total] < 0 || empty($DealerCode)) {   
		        $result = false ;
		        $error = 1 ;
		        $payment_error_return = 'payment_error=' . $this->code . '&error=' . urlencode($error) ;
		        xtc_redirect(xtc_href_link(FILENAME_CHECKOUT_PAYMENT, $payment_error_return, 'SSL', true, false));
	     } else {
		      $result = true ;
	     }
	     return $result ;
    }


    function confirmation() { 
      global $order,$db ;
      if ( $_SESSION['step'] == "" ) {
  			$_SESSION['step'] = 1 ;
  	  } else {
  			$_SESSION['step']++ ;
  	  }
  	//商家代號及參數          
    $DealerCode=MODULE_PAYMENT_SMILEPAYATM_DEALERCODE;
    if ($DealerCode==" ") {
			  $DealerCode = "9999999" ;			
	  }   
        
    //加密參數    
  	$encode=MODULE_PAYMENT_SMILEPAYATM_PASSCODE;
  	$passcode=$DealerCode .$encode;
  	$passcode_in=sha1($passcode);	
    //訂單編號計算
 	  $oid_query =xtc_db_query("select orders_id CNT from " . TABLE_ORDERS . " ORDER BY orders_id DESC LIMIT 1" );
  	$oid_array = xtc_db_fetch_array($oid_query);  
  	$oid_array=$oid_array['CNT']+1;
	  $oid = date('mdHi')."-".$oid_array;
	  //客戶姓名-地址-消費項目
	  $customer=$order->customer['firstname'] .$order->customer['lastname'];	  
	  $street_address = $order->customer['state'] . $order->customer['city'] .  $order->customer['street_address'] ;
    //$sname=STORE_NAME."_".$order->products[0]['name'];     
    $sname=mb_substr($order->products[0]['name'],0,14,'utf-8');
	  //讀取簡訊設定    
    $SMSCA = MODULE_PAYMENT_SMILEPAYATM_SMS_CA ;   
    $SMSSB = MODULE_PAYMENT_SMILEPAYATM_SMS_SB ;	
    $SMSCUSB = MODULE_PAYMENT_SMILEPAYATM_SMS_CUSB ;
    //回傳respond位置  
    $locallink=( ENABLE_SSL ?  'https://' : 'http://' ) . $_SERVER['SERVER_NAME']. substr($_SERVER['PHP_SELF'], 0, strrpos($_SERVER['PHP_SELF'],"/") + 1);
    $roturl=$locallink."smilepayrespond.php";    
         
      //post表單
    $pargams =  'Dcvc=' .$DealerCode.
                              '&Rvg2c=1'.              
                              '&Amount=' .urlencode(round($order->info[total])).
                              '&Remark=' . $passcode_in.                              
                              '&Data_id=' . $oid . "-" . substr(($_SESSION['step']+100),1).
                              '&Od_sob=' .$sname.
                              '&Pur_name=' .$customer.
                              '&Address=' . $street_address.
                              '&Email=' .$order->customer['email_address'].
                              '&Mobile_pur='.$order->customer['fax'].
                              '&Pay_zg=2'.
                              '&Pay_gdry=TW'.
                              '&Mobile_rvg=' . $SMSCA.
                              '&Sms_rvg=' . $SMSSB.
                              '&Sms_pur='.$SMSCUSB.
                              '&Tel_number='.$order->customer['telephone'].
                              '&Roturl_status=xtcok'.                              
                              '&Roturl=' . $roturl;                                                                                                                                                          
                             //'&xtcsid=' . xtc_session_id();

//MODULE_PAYMENT_SMILEPAYATM_KEY_URL
     $pay_button = '<a href="'.MODULE_PAYMENT_SMILEPAYATM_KEY_URL.'?'.$pargams.'" target="_blank" onclick="validate()"><button type="button">'.MODULE_PAYMENT_SMILEPAYATM_PAYER_BUTTON.'</button></a>';                          
     $scripts='<script>function validate(){
     document.forms["checkout_confirmation"].submit();
}</script>';                            
     return array('title' => MODULE_PAYMENT_SMILEPAYATM_PAYER_NAME ,      
     'fields' => array(
      // array('title'=>MODULE_PAYMENT_SMILEPAYATM_PAYER_EMAIL,'field'=>$order->customer['email_address']),
       //array('title'=>MODULE_PAYMENT_SMILEPAYATM_PAYER_CELLPHONE,'field'=>$order->customer['fax']),
       //array('title'=>MODULE_PAYMENT_SMILEPAYATM_PAYER_AMOUNT,'field'=>urlencode(round($order->info[total]))),
       array('title'=>'','field'=>$scripts),
       array('title'=>'','field'=>$pay_button),
       array('title'=>'','field'=>MODULE_PAYMENT_SMILEPAYATM_PAYER_NOTICE),
       array('title'=>'','field'=>MODULE_PAYMENT_SMILEPAYATM_PAYER_NOTICE_DOWN)
      )
     );       
    }

    function process_button() {
      global $order,$db,$customer_id ;
  	  if ( $_SESSION['step'] == "" ) {
  			$_SESSION['step'] = 1 ;
  	  } else {
  			$_SESSION['step']++ ;
  	  }
        

    //訂單編號計算
 	  $oid_query =xtc_db_query("select orders_id CNT from " . TABLE_ORDERS . " ORDER BY orders_id DESC LIMIT 1" );
	  $oid_array = xtc_db_fetch_array($oid_query);
	  $oid_id=$oid_array['CNT']+1;
	  $oid = date('mdHi')."-".$oid_id;
 
        
      //post表單
    $process_button_string =xtc_draw_hidden_field('Data_id', $oid . "-" . substr(($_SESSION['step']+100),1));
			                                                 
      return  $process_button_string;
	}                                                    

  function before_process() {                                                                
      return false;
  }
  
  function after_process() {		                       
		global $insert_id,$db ;
		$_SESSION['PAYMENTOID'] = $_POST['Data_id'] ;     		
		xtc_db_query("update ".TABLE_ORDERS." set cc_owner='".$_SESSION['AUTHCODE']."', cc_number ='".$_SESSION['PAYMENTOID']."' where orders_id='".(int)$insert_id ."'");		
		unset($_SESSION['AUTHCODE']) ;                      
		unset($_SESSION['PAYMENTOID']) ;
		unset($_SESSION['step']) ;                           
    return true;
  } 
                                                       
  function respond(){
    global $db ;                                         
    $mitycat_type       = $_POST['Classif'];
    $mitycat_order      = $_POST['Data_id'];   
    $amount             = $_POST['Amount'];  
    $passcode_in        = $_POST['Remark'];
    $smseid             = $_REQUEST['Smseid'];  
    $mid_smilepay       = $_POST['Mid_smilepay'];    
        
    $DealerCode=MODULE_PAYMENT_SMILEPAYATM_DEALERCODE;
	  $encode=MODULE_PAYMENT_SMILEPAYATM_PASSCODE;                
  	$passcode=$DealerCode .$encode;
  	$passcode_ou=sha1($passcode);                                                      	
    
      //checksum Mid and Mid_smilepay from SmielPay    
      $mid=MODULE_PAYMENT_SMILEPAYATM_MID;
      $mid_value=MODULE_PAYMENT_SMILEPAYATM_MID_VALUE;                               
      if($mid == 'True'){                         
        if(!$this->midfun($mid_value,$amount,$smseid,$mid_smilepay)){      
          echo  "Possible fraud";
          exit();
        }        
      }
      

	  
     //check Amount 
    $order_id =explode ("-", $mitycat_order);    
    $totals = xtc_db_query("select value from " . TABLE_ORDERS_TOTAL . " where orders_id = '" . xtc_db_input($order_id[1]) . "' and class = 'ot_total' order by sort_order");
    $totals_array = xtc_db_fetch_array($totals);
    $db_totals_value = $totals_array['value'];
    
    if((int)$db_totals_value != $amount){
          echo  "Possible fraud Amount different";
          exit();
    }           
                                                           
    //判斷付費方式                                       
    if(($passcode_in == $passcode_ou && !empty($amount)) && $mitycat_type == 'B' ){
    $mitycat_transnum   = "追蹤碼:".$_REQUEST['Smseid']; 
    $orders_status=MODULE_PAYMENT_SMILEPAYATM_ORDERED_STATUS_ID;  
    $comments='paid';
    $oID=explode ("-", $mitycat_order);
    xtc_db_query("insert into " . TABLE_ORDERS_STATUS_HISTORY . " (orders_id, orders_status_id, date_added, customer_notified, comments) values ('" . (int)$oID[1] . "', '" .$orders_status . "', now(), '', '".$mitycat_transnum."')");    
    xtc_db_query("update " . TABLE_ORDERS . " set cc_type = '" . $_REQUEST['Smseid'] . "',orders_status='".$orders_status."' ,last_modified = now(),cc_expires ='".$comments."'  where orders_id = '" . (int)$oID[1] . "'");        
      return "xtcok";                               
    }
    else {                                                 
      return false;
    }                                                      
  }
  function get_error() {                                   
	  switch ($_GET['error']) {
		  case 1 :
		  	$error_message = MODULE_PAYMENT_SMILEPAYATM_TEXT_ERROR_1 ;
		  break ;
		  case 2 :
		  	$error_message = MODULE_PAYMENT_SMILEPAYATM_TEXT_ERROR_2 ;
		  break ;
	  }
      $error = array('title' => MODULE_PAYMENT_SMILEPAYATM_TEXT_ERROR,
                     'error' => $error_message );
    return $error;                                         
  }

    function remove() {
    	global $db;
      xtc_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array('MODULE_PAYMENT_SMILEPAYATM_ALLOWED', 'MODULE_PAYMENT_SMILEPAYATM_STATUS', 'MODULE_PAYMENT_SMILEPAYATM_ZONE', 'MODULE_PAYMENT_SMILEPAYATM_ORDER_STATUS_ID',  'MODULE_PAYMENT_SMILEPAYATM_DEALERCODE','MODULE_PAYMENT_SMILEPAYATM_PASSCODE', 'MODULE_PAYMENT_SMILEPAYATM_SORT_ORDER','MODULE_PAYMENT_SMILEPAYATM_SMS_CA','MODULE_PAYMENT_SMILEPAYATM_SMS_SB','MODULE_PAYMENT_SMILEPAYATM_SMS_CUSB','MODULE_PAYMENT_SMILEPAYATM_ORDERED_STATUS_ID','MODULE_PAYMENT_SMILEPAYATM_MID','MODULE_PAYMENT_SMILEPAYATM_MID_VALUE');
    }

	function check() {
	    global $db;
      if (!isset($this->_check)) {
        $check_query = xtc_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_SMILEPAYATM_STATUS'");        
        $this->_check = xtc_db_num_rows($check_query);
      }
      return $this->_check;
  }

    function install() {
    	global $db;
      xtc_db_query("insert into " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, date_added) values ('MODULE_PAYMENT_SMILEPAYATM_ALLOWED', '', '6', '0', now())");
      xtc_db_query("insert into " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, set_function, date_added) values ('MODULE_PAYMENT_SMILEPAYATM_STATUS', 'True', '6', '1', 'xtc_cfg_select_option(array(\'True\', \'False\'), ', now());");
      xtc_db_query("insert into " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, use_function, set_function, date_added) values ('MODULE_PAYMENT_SMILEPAYATM_ZONE', '0', '6', '2', 'xtc_get_zone_class_title', 'xtc_cfg_pull_down_zone_classes(', now())");
      xtc_db_query("insert into " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, set_function, use_function, date_added) values ('MODULE_PAYMENT_SMILEPAYATM_ORDER_STATUS_ID', '0', '6', '3', 'xtc_cfg_pull_down_order_statuses(', 'xtc_get_order_status_name', now())");
      xtc_db_query("insert into " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, set_function, use_function, date_added) values ('MODULE_PAYMENT_SMILEPAYATM_ORDERED_STATUS_ID', '0', '6', '3', 'xtc_cfg_pull_down_order_statuses(', 'xtc_get_order_status_name', now())");
      xtc_db_query("insert into " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, date_added) values ('MODULE_PAYMENT_SMILEPAYATM_DEALERCODE', '', '6', '4', now());");      
      xtc_db_query("insert into " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, date_added) values ('MODULE_PAYMENT_SMILEPAYATM_PASSCODE', '', '6', '6', now());");
      xtc_db_query("insert into " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, date_added) values ('MODULE_PAYMENT_SMILEPAYATM_SORT_ORDER', '0', '6', '7', now())");
      xtc_db_query("insert into " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, date_added) values ('MODULE_PAYMENT_SMILEPAYATM_SMS_CA','','6','8', now())");
      xtc_db_query("insert into " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, date_added) values ('MODULE_PAYMENT_SMILEPAYATM_SMS_SB', '', '6', '9', now());");
      xtc_db_query("insert into " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, date_added) values ('MODULE_PAYMENT_SMILEPAYATM_SMS_CUSB', '', '6', '10', now());");
      xtc_db_query("insert into " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, set_function, date_added) values ('MODULE_PAYMENT_SMILEPAYATM_MID', 'False', '6', '6', 'xtc_cfg_select_option(array(\'True\', \'False\'), ', now());");
      xtc_db_query("insert into " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, date_added) values ('MODULE_PAYMENT_SMILEPAYATM_MID_VALUE', '', '6', '6', now());");
      

  }
  
  
  // compute Mid      
  function midfun($Mid_value,$Amount,$Smseid,$Mid_smilepay){   
    $Amount = str_pad($Amount,8,'0',STR_PAD_LEFT);                   
    $Smseid= preg_replace('/[\D]/i','9',substr($Smseid,-4));      
    $dtotal=$Mid_value. $Amount. $Smseid;                              
    
    $i = 1;
    $sum = strlen($dtotal);
    $etemp=0;      
    while ($i <= $sum)
    {
      $ep = substr($dtotal,$i,1);
      $etemp = $etemp + $ep;                
      $i=$i+2;
    }                
    
    $i = 0;  
    $otemp=0;          
    while ($i <= $sum)
    {                                              
      $op = substr($dtotal,$i,1);
      $otemp = $otemp + $op;
      $i=$i+2;
    } 
    
    $mid=($etemp*3)+($otemp*9);
  
    if($Mid_smilepay == $mid){
      return true;
    }else{
      return false;
    }
       
  }  
  
}
?>
