<?php
class smilepaycredit {
    var $code, $title, $titlep, $description, $enabled;

	function smilepaycredit() {
      global $order,$db;

      $this->code = 'smilepaycredit';
      $this->title = MODULE_PAYMENT_SMILEPAYCREDIT_TEXT_TITLE;
      $this->titlep = MODULE_PAYMENT_SMILEPAYCREDIT_TEXT_TITLEP;
      $this->description = MODULE_PAYMENT_SMILEPAYCREDIT_TEXT_DESCRIPTION;
      $this->sort_order = MODULE_PAYMENT_SMILEPAYCREDIT_SORT_ORDER;
      $this->enabled = ((MODULE_PAYMENT_SMILEPAYCREDIT_STATUS == 'True') ? true : false);
      $this->form_action_url = MODULE_PAYMENT_SMILEPAYCREDIT_KEY_URL;
      
      if ((int)MODULE_PAYMENT_SMILEPAYCREDIT_ORDER_STATUS_ID > 0) {
        $this->order_status = MODULE_PAYMENT_SMILEPAYCREDIT_ORDER_STATUS_ID;
      }

   }

	function update_status() {
      global $order,$db;

      if ( ($this->enabled == true) && ((int)MODULE_PAYMENT_SMILEPAYCREDIT_ZONE > 0) ) {
        $check_flag = false;
        $check_query = xtc_db_query("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_SMILEPAYCREDIT_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
        while ($check = tep_db_fetch_array($check_query)) {
          if ($check['zone_id']  < 1) {
            $check_flag = true;
            break;
          } elseif ($check['zone_id']  == $order->billing['zone_id']) {
            $check_flag = true;
            break;
          }        

        if ($check_flag == false) {
          $this->enabled = false;
        }
      }
      }
    }

    function javascript_validation() {
      return false;
    }

    function selection() {	
        $selection = array('id' => $this->code,
                       'module' => $this->titlep,
                       'fields' => array(array('title' => MODULE_PAYMENT_SMILEPAYCREDIT_PAYER_NAME,),));
        return $selection;               
	}

    function pre_confirmation_check() {
      global $order,$HTTP_POST_VARS;
      $DealerCode=MODULE_PAYMENT_SMILEPAYCREDIT_DEALERCODE;
      if ( $order->info[total] < 0 || empty($DealerCode)) {
    		  $result = false ;
    		  $error = 1 ;
    		  $payment_error_return = 'payment_error=' . $this->code . '&error=' . urlencode($error) ;
    		  xtc_redirect(xtc_href_link(FILENAME_CHECKOUT_PAYMENT, $payment_error_return, 'SSL', true, false));
	    } else {
		      $result = true ;
	    }
	    return $result ;
    }


    function confirmation() {
      return array('title' => MODULE_PAYMENT_SMILEPAYCREDIT_TEXT_CONFIRMATION);
    }

    function process_button() {
      global $order,$db,$customer_id ;
      
  	  if ( $_SESSION['step'] == "" ) {
  			$_SESSION['step'] = 1 ;
  	  } else {
  			$_SESSION['step']++ ;
  	  }
  	//商家代號及參數          
    $DealerCode=MODULE_PAYMENT_SMILEPAYCREDIT_DEALERCODE;
    if ($DealerCode=="") {
			  $DealerCode = "9999999" ;			
	  }        
    //加密參數    
  	$encode=MODULE_PAYMENT_SMILEPAYCREDIT_PASSCODE;
  	$passcode=$DealerCode .$encode;
  	$passcode_in=sha1($passcode);
    //訂單編號計算
 	  $oid_query =xtc_db_query("select orders_id CNT from " . TABLE_ORDERS . " ORDER BY orders_id DESC LIMIT 1" );
  	$oid_array = xtc_db_fetch_array($oid_query);  
  	$oid_array=$oid_array['CNT']+1;

	  $oid = date('dHis')."-".$oid_array;
	  //客戶姓名-地址-消費項目
	  $customer=$order->customer['firstname'] .$order->customer['lastname'];	  
	  $street_address = $order->customer['state'] . $order->customer['city'] .  $order->customer['street_address'] ;
    //$sname=STORE_NAME."_".$order->products[0]['name'];
    $sname=mb_substr($order->products[0]['name'],0,14,'utf-8');
     //讀取簡訊設定    
    $SMSCA = MODULE_PAYMENT_SMILEPAYCREDIT_SMS_CA ;   
    $SMSSB = MODULE_PAYMENT_SMILEPAYCREDIT_SMS_SB ;	
    $SMSCUSB = MODULE_PAYMENT_SMILEPAYCREDIT_SMS_CUSB ;
    //回傳respond位置  
    $locallink=( ENABLE_SSL ?  'https://' : 'http://' ) . $_SERVER['SERVER_NAME']. substr($_SERVER['PHP_SELF'], 0, strrpos($_SERVER['PHP_SELF'],"/") + 1);
    $roturl=$locallink."smilepayrespond.php"; 
    //post表單
    $process_button_string = xtc_draw_hidden_field('Dcvc', $DealerCode) .
                              xtc_draw_hidden_field('Rvg2c', "1") .              
                              xtc_draw_hidden_field('Amount', urlencode(round($order->info[total]))) .
                              xtc_draw_hidden_field('Remark', $passcode_in) .                              
                              xtc_draw_hidden_field('Data_id', $oid . "-" . substr(($_SESSION['step']+100),1)) .
                              xtc_draw_hidden_field('Od_sob', $sname).
                              xtc_draw_hidden_field('Pur_name', $customer).
                              xtc_draw_hidden_field('Address', $street_address ).
                              xtc_draw_hidden_field('Email',$order->customer['email_address']).
                              xtc_draw_hidden_field('Mobile_rvg', $SMSCA) .
                              xtc_draw_hidden_field('Sms_rvg', $SMSSB) .
                              xtc_draw_hidden_field('Mobile_pur',$order->customer['fax']).
                              xtc_draw_hidden_field('Sms_pur',$SMSCUSB).
                              xtc_draw_hidden_field('Pay_zg',"1").
                              xtc_draw_hidden_field('Pay_gdry',"TW").
                              xtc_draw_hidden_field('Tel_number',$order->customer['telephone']).                                                         
                              xtc_draw_hidden_field('Roturl', $roturl) .                                                                                                 
                              xtc_draw_hidden_field('XTCsid', xtc_session_id());

    return $process_button_string;
	}

    function before_process() {   
  	    return false;
    }
    function after_process() {
      global $insert_id,$db ; 
  		$_SESSION['PAYMENTOID'] = $_POST['Data_id'] ;     		
  		xtc_db_query("update ".TABLE_ORDERS." set cc_owner='".$_SESSION['PAYMENTOID']."' where orders_id='".(int)$insert_id ."'");		
  		unset($_SESSION['AUTHCODE']) ;
  		unset($_SESSION['PAYMENTOID']) ;
  		unset($_SESSION['step']) ;     
      return true;          
    }
    
    function respond(){
     global $db ;  
      $respid             = $_POST['Response_id'];
      $mitycat_type       = $_POST['Classif'];
      $mitycat_order      = $_POST['Data_id'];
      $amount             = $_POST['Amount'];
      $Purchamt             = $_POST['Purchamt'];
      $passcode_in        = $_POST['Remark'];      
      $smseid             = $_REQUEST['Smseid'];  
      $mid_smilepay       = $_POST['Mid_smilepay'];
      $LastPan       = $_POST['LastPan'];  
            
  	  $DealerCode=MODULE_PAYMENT_SMILEPAYCREDIT_DEALERCODE;
  	  $encode=MODULE_PAYMENT_SMILEPAYCREDIT_PASSCODE;        
    	$passcode=$DealerCode .$encode;
    	$passcode_ou=sha1($passcode);
       
      //checksum Mid and Mid_smilepay from SmielPay    
      $mid=MODULE_PAYMENT_SMILEPAYCREDIT_MID;
      $mid_value=MODULE_PAYMENT_SMILEPAYCREDIT_MID_VALUE;                               
      if($mid == 'True'){             
        if(!$this->midfun($mid_value,$Purchamt,$smseid,$mid_smilepay)){      
          echo  "Possible fraud";
          exit();
        }        
      }          
      
      if(($passcode_in == $passcode_ou && !empty($amount))&& ($mitycat_type == 'A' && $respid=='1')){      
        $mitycat_transnum   = "追蹤碼:".$_REQUEST['Smseid']."已銷案";
        $orders_status=MODULE_PAYMENT_SMILEPAYCREDIT_ORDERED_STATUS_ID;
        $oID=explode ("-", $mitycat_order);
        xtc_db_query("insert into " . TABLE_ORDERS_STATUS_HISTORY . " (orders_id, orders_status_id, date_added, customer_notified, comments) values ('" . (int)$oID[1] . "', '" .$orders_status . "', now(), '', '".$mitycat_transnum."')");
        xtc_db_query("update " . TABLE_ORDERS . " set cc_type = '" . $_REQUEST['Smseid'] . "',orders_status='".$orders_status."' ,cc_number = '" . $LastPan . "',last_modified = now()  where cc_owner = '" . $mitycat_order . "'");                        
        //xtc_session_unregister('payment');        
        //$_SESSION['cart']->reset(true);
        $msg=xtc_redirect(xtc_href_link(FILENAME_CHECKOUT_SUCCESS, '', 'SSL', true, false));        
        return $msg;        
          
        }else{
        $Errdesc   = iconv("big5","UTF-8", $_REQUEST['Errdesc']); 
  			$payment_error_return = 'errdesc=' . $Errdesc ;
        $oID=explode ("-", $mitycat_order);
        $orders_status=MODULE_PAYMENT_SMILEPAYCREDIT_ORDERED_FAILED_STATUS_ID;
        xtc_db_query("insert into " . TABLE_ORDERS_STATUS_HISTORY . " (orders_id, orders_status_id, date_added, customer_notified, comments) values ('" . (int)$oID[1] . "', '" .$orders_status . "', now(), '', '".$Errdesc."')");
        xtc_db_query("update " . TABLE_ORDERS . " set cc_type = '" . $_REQUEST['Smseid'] . "',orders_status='".$orders_status."' ,last_modified = now()  where cc_owner = '" . $mitycat_order . "'");
  			xtc_redirect(xtc_href_link("checkout_failed.php", $payment_error_return, 'SSL', true, false));  			
  	    return false;
      }
     }    

    function get_error() {
	  switch ($_GET['error']) {
		  case 1 :
		  	$error_message = MODULE_PAYMENT_SMILEPAYCREDIT_TEXT_ERROR_1 ;
		  break ;
		  case 2 :
		  	$error_message = MODULE_PAYMENT_SMILEPAYCREDIT_TEXT_ERROR_2 ;
		  break ;
	  }
      $error = array('title' => MODULE_PAYMENT_SMILEPAYCREDIT_TEXT_ERROR,
                     'error' => $error_message );
      return $error;
    }

    function remove() {
    	global $db;
      xtc_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array('MODULE_PAYMENT_SMILEPAYCREDIT_ALLOWED', 'MODULE_PAYMENT_SMILEPAYCREDIT_STATUS', 'MODULE_PAYMENT_SMILEPAYCREDIT_ZONE', 'MODULE_PAYMENT_SMILEPAYCREDIT_ORDER_STATUS_ID',  'MODULE_PAYMENT_SMILEPAYCREDIT_DEALERCODE','MODULE_PAYMENT_SMILEPAYCREDIT_PASSCODE', 'MODULE_PAYMENT_SMILEPAYCREDIT_SORT_ORDER','MODULE_PAYMENT_SMILEPAYCREDIT_SMS_CA','MODULE_PAYMENT_SMILEPAYCREDIT_SMS_SB','MODULE_PAYMENT_SMILEPAYCREDIT_SMS_CUSB','MODULE_PAYMENT_SMILEPAYCREDIT_ORDERED_STATUS_ID','MODULE_PAYMENT_SMILEPAYCREDIT_ORDERED_FAILED_STATUS_ID','MODULE_PAYMENT_SMILEPAYCREDIT_MID','MODULE_PAYMENT_SMILEPAYCREDIT_MID_VALUE');
    }

	function check() {
	global $db;
      if (!isset($this->_check)) {
        $check_query = xtc_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_SMILEPAYCREDIT_STATUS'");
        $this->_check = xtc_db_num_rows($check_query);
      }
      return $this->_check;
    }

    function install() {
    	global $db;
      xtc_db_query("insert into " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, date_added) values ('MODULE_PAYMENT_SMILEPAYCREDIT_ALLOWED', '', '6', '0', now())");
      xtc_db_query("insert into " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, set_function, date_added) values ('MODULE_PAYMENT_SMILEPAYCREDIT_STATUS', 'True', '6', '1', 'xtc_cfg_select_option(array(\'True\', \'False\'), ', now());");
      xtc_db_query("insert into " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, use_function, set_function, date_added) values ('MODULE_PAYMENT_SMILEPAYCREDIT_ZONE', '0', '6', '2', 'xtc_get_zone_class_title', 'xtc_cfg_pull_down_zone_classes(', now())");
      xtc_db_query("insert into " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, set_function, use_function, date_added) values ('MODULE_PAYMENT_SMILEPAYCREDIT_ORDER_STATUS_ID', '0', '6', '3', 'xtc_cfg_pull_down_order_statuses(', 'xtc_get_order_status_name', now())");
      xtc_db_query("insert into " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, set_function, use_function, date_added) values ('MODULE_PAYMENT_SMILEPAYCREDIT_ORDERED_STATUS_ID', '0', '6', '3', 'xtc_cfg_pull_down_order_statuses(', 'xtc_get_order_status_name', now())");
      xtc_db_query("insert into " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, set_function, use_function, date_added) values ('MODULE_PAYMENT_SMILEPAYCREDIT_ORDERED_FAILED_STATUS_ID', '0', '6', '3', 'xtc_cfg_pull_down_order_statuses(', 'xtc_get_order_status_name', now())");      
      xtc_db_query("insert into " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, date_added) values ('MODULE_PAYMENT_SMILEPAYCREDIT_DEALERCODE', '', '6', '4', now());");    
      xtc_db_query("insert into " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, date_added) values ('MODULE_PAYMENT_SMILEPAYCREDIT_PASSCODE', '', '6', '6', now());");
      xtc_db_query("insert into " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, date_added) values ('MODULE_PAYMENT_SMILEPAYCREDIT_SORT_ORDER', '0', '6', '0', now())");
      xtc_db_query("insert into " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, date_added) values ('MODULE_PAYMENT_SMILEPAYCREDIT_SMS_CA','','6','7', now())");
      xtc_db_query("insert into " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, date_added) values ('MODULE_PAYMENT_SMILEPAYCREDIT_SMS_SB', '', '6', '1', now());");
      xtc_db_query("insert into " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, date_added) values ('MODULE_PAYMENT_SMILEPAYCREDIT_SMS_CUSB', '', '6', '1', now());");
      xtc_db_query("insert into " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, set_function, date_added) values ('MODULE_PAYMENT_SMILEPAYCREDIT_MID', 'False', '6', '6', 'xtc_cfg_select_option(array(\'True\', \'False\'), ', now());");
      xtc_db_query("insert into " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, date_added) values ('MODULE_PAYMENT_SMILEPAYCREDIT_MID_VALUE', '', '6', '6', now());");      
  }
  
  // compute Mid      
  function midfun($Mid_value,$Amount,$Smseid,$Mid_smilepay){   
    $Amount = str_pad($Amount,8,'0',STR_PAD_LEFT);                   
    $Smseid= preg_replace('/[\D]/i','9',substr($Smseid,-4));      
    $dtotal=$Mid_value. $Amount. $Smseid;                              
    
    $i = 1;
    $sum = strlen($dtotal);
    $etemp=0;      
    while ($i <= $sum)
    {
      $ep = substr($dtotal,$i,1);
      $etemp = $etemp + $ep;                
      $i=$i+2;
    }                
    
    $i = 0;  
    $otemp=0;          
    while ($i <= $sum)
    {                                              
      $op = substr($dtotal,$i,1);
      $otemp = $otemp + $op;
      $i=$i+2;
    } 
    
    $mid=($etemp*3)+($otemp*9);
  
    if($Mid_smilepay == $mid){
      return true;
    }else{
      return false;
    }
       
  }  

}
?>
